<template>
  <v-card flat>
    <v-card-text>
      <v-row justify="center">
        <v-col cols="9" md="6">
          <v-slider
            v-model="mode"
            :tick-labels="modes.map((element) => element.label)"
            :max="modes.length - 1"
            :color="modes[mode].color"
            step="1"
            ticks="always"
            tick-size="3"
            thumb-label
          >
            <template v-slot:thumb-label>
              <v-icon dark>{{ modes[mode].icon }}</v-icon>
            </template>
          </v-slider>
        </v-col>
      </v-row>

      <v-row justify="center">
        <v-col cols="9" md="6">
          <v-card class="mx-auto" outlined>
            <v-row align="center">
              <v-col cols="8" md="10">
                <v-card-title class="headline">{{
                  modes[mode].label
                }}</v-card-title>
                <v-card-subtitle class="body-2">{{
                  modes[mode].description
                }}</v-card-subtitle>
              </v-col>
              <v-col>
                <v-icon x-large :color="modes[mode].color">{{
                  modes[mode].icon
                }}</v-icon>
              </v-col>
            </v-row>
            <v-card-text>
              <p class="text-left">
                <span class="body-1">Real-time plot</span>
                <span
                  class="overline ml-2"
                  :class="{
                    'red--text text--darken-1': !chartEnabled,
                    'green--text text--darken-1': chartEnabled,
                  }"
                  >{{ chartEnabled ? "Enabled" : "Disabled" }}</span
                >
              </p>
              <p class="text-left">
                <span class="body-1">Buffer size</span>
                <span
                  class="overline ml-2"
                  :class="{
                    'red--text text--darken-1': !infiniteBuffer,
                    'green--text text--darken-1': infiniteBuffer,
                  }"
                  >{{ infiniteBuffer ? "Unlimited" : "Limited" }}</span
                >
              </p>
            </v-card-text>
          </v-card>

          <v-list subheader two-line>
            <v-subheader>Folders</v-subheader>
            <v-list-item
              v-for="(value, name) in paths"
              :key="value + ' ' + name"
            >
              <v-list-item-icon>
                <v-icon>mdi-folder</v-icon>
              </v-list-item-icon>
              <v-list-item-content>
                <v-list-item-title v-text="name.charAt(0).toUpperCase() + name.substr(1).toLowerCase()"></v-list-item-title>
                <v-list-item-subtitle v-text="value"></v-list-item-subtitle>
              </v-list-item-content>
              <v-list-item-action>
                <v-btn text @click="openFolder(name)">Open <v-icon right>mdi-folder-open</v-icon></v-btn>
              </v-list-item-action>
            </v-list-item>
          </v-list>
        </v-col>
      </v-row>
    </v-card-text>
  </v-card>
</template>

<script>
export default {
  data: () => ({
    modes: [
      {
        label: "Low",
        icon: "mdi-speedometer-slow",
        description: "Fast and lightweight, only logs to file",
        color: "teal",
      },
      {
        label: "Medium",
        icon: "mdi-speedometer-medium",
        description: "Real-time plot with limited buffer size",
        color: "green",
      },
      {
        label: "High",
        icon: "mdi-speedometer",
        description: "Real-time plot with UNLIMITED buffer size (very resource heavy)",
        color: "orange",
      },
    ],
    paths: {},
  }),
  computed: {
    mode: {
      get() {
        return this.$store.getters["settings/mode"];
      },
      set(value) {
        this.$store.dispatch("settings/setMode", value);
        this.$axios
          .post("/settings", {
            option: "mode",
            value: value,
          })
          .then(() => {})
          .catch(() => {
            this.$notify.error("Error while saving settings");
          });
      },
    },
    chartEnabled() {
      return this.$store.getters["settings/chart"];
    },
    infiniteBuffer() {
      return this.$store.getters["settings/infinite_buffer"];
    },
  },
  methods: {
    getPaths() {
      this.$axios
        .get("/filesystem")
        .then((res) => {
          this.paths = res.data;
        })
        .catch(() => {
          this.$notify.error("Error while retrieving paths");
        });
    },
    openFolder(name) {
      this.$axios
        .post("/open", {
          is_path: false,
          path: name,
        })
        .then(() => {})
        .catch(() => {});
    },
  },
  mounted() {
    this.getPaths();
  },
};
</script>